log.lik.basal <- function(z,Y)
{
  C_0_gamma <- exp(z[1:length(S_x_vec)])
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dnorm(u,mean=u_bar,sd=cur_sd_x, log=TRUE))+sum(dnorm(v,mean=v_bar,sd=cur_sd_y,log=TRUE)))
}
log.lik.basal.t <- function(z,Y)
{
  C_0_gamma <- exp(z[1:length(S_x_vec)])
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dt.scaled(u,mean=u_bar, sd = cur_sd_x, df = dof, log = TRUE))+sum(dt.scaled(v,mean=v_bar, sd = cur_sd_y, df = dof, log = TRUE)))
}

log.lik.scale.x.t <- function(z,Y)
{
  C_0_gamma <- exp(cur_basal_sliding)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dt.scaled(u,mean=u_bar, sd = z, df = dof, log = TRUE)))
}

log.lik.scale.x.t <- function(z,Y)
{
  C_0_gamma <- exp(cur_basal_sliding)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dt.scaled(u,mean=u_bar, sd = z, df = dof, log = TRUE)))
}

log.lik.scale.y.t <- function(z,Y)
{
  C_0_gamma <- exp(cur_basal_sliding)
  C_star <- (31556926)*(2*B_cur)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dt.scaled(v,mean=v_bar, sd = z, df = dof, log = TRUE)))
}

log.lik.B <- function(B,Y)
{
  C_0_gamma <- exp(cur_basal_sliding)
  C_star <- (31556926)*(2*B)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dnorm(u,mean=u_bar,sd=cur_sd_x, log=TRUE))+sum(dnorm(v,mean=v_bar,sd=cur_sd_y,log=TRUE)))
}
log.lik.B.t <- function(B,Y)
{
  C_0_gamma <- exp(cur_basal_sliding)
  C_star <- (31556926)*(2*B)*((rho*g)^n)/(n+1)
  u_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_x_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_x_vec)
  v_bar <- C_0_gamma*(-rho*g_const*thickness_vals*S_y_vec)+C_star*alpha*thickness_vals^n*(-1*thickness_vals*S_y_vec)
  u <- Y[1:length(thickness_vals)]
  v <- Y[(length(thickness_vals)+1):(2*length(thickness_vals))]
  return(sum(dt.scaled(u,mean=u_bar, sd = cur_sd_x, df = dof, log = TRUE))+sum(dt.scaled(v,mean=v_bar, sd = cur_sd_y, df = dof, log = TRUE)))
}
log.prior.B <- function(B_prop)
{
  return(dnorm(x=B_prop,mean=35*10^(-25),sd=3*10^(-24),log=TRUE))
}
log.prior.B.NEW <- function(B_prop)
{
  return(dinvgamma(B_prop/(10^(-25)), shape = 3, rate = 70, log = TRUE))
}
log.prior.sd.t <- function(sd_prop)
{
  return(dinvgamma(sd_prop^2, shape = 3, rate = 4, log = TRUE))+log(2)+log(sd_prop)
}
ess_step <- function(prev_sample,Y,Sig_mat)
{
  f <- prev_sample
  llh_thresh <- log.lik.basal(f, Y) + log(runif(1))
  theta <- runif(1,min=0,max=2*pi)
  theta_min <- theta - 2 * pi
  theta_max <- theta + 2 * pi
  norm_sample <- mvrnorm(n =1, mu = rep(0,dim(Sig_mat)[1]), Sigma = Sig_mat, tol = 1e-06)
  f_star <- f * cos(theta) + norm_sample* sin(theta)
  while (log.lik.basal(f_star, Y) < llh_thresh) {
    if (theta < 0) {
      theta_min <- theta
    }
    else {
      theta_max <- theta
    }
    theta <- runif(n = 1, min = theta_min, max = theta_max)
    f_star <- f*cos(theta) + norm_sample*sin(theta)
  }
  return(f_star)
}

ess_step_t <- function(prev_sample,Y,Sig_mat)
{
  f <- prev_sample
  llh_thresh <- log.lik.basal.t(f, Y) + log(runif(1))
  theta <- runif(1,min=0,max=2*pi)
  theta_min <- theta - 2 * pi
  theta_max <- theta + 2 * pi
  norm_sample <- mvrnorm(n =1, mu = rep(0,dim(Sig_mat)[1]), Sigma = Sig_mat, tol = 1e-06)
  f_star <- f * cos(theta) + norm_sample* sin(theta)
  while (log.lik.basal.t(f_star, Y) < llh_thresh) {
    if (theta < 0) {
      theta_min <- theta
    }
    else {
      theta_max <- theta
    }
    theta <- runif(n = 1, min = theta_min, max = theta_max)
    f_star <- f*cos(theta) + norm_sample*sin(theta)
  }
  return(f_star)
}