#surface_velocity analysis at Lang
#uncomment to install packages
#install.packages('FastGP')
#install.packages('MASS')
#install.packages('invgamma')
#install.packages('fields')
#install.packages('coda')
#install.packages('metRology')

library(FastGP)
library(MASS)
library(invgamma)
library(fields)
library(coda)
library(metRology)

#make sure to setwd where SV_setup.RData is located
load('setup_dat.RData')
#gravitational constant
g <- g_const
test_Y <- c(velocity_x, velocity_y)

#test for correlation between x and y velocity components
cor.test(velocity_x, velocity_y, method = 'kendall')